#include <windows.h>
#include <stdlib.h>
#include <wtypes.h>
#include <conio.h>
#include <stdio.h>
#include "main.h"



TIM NOTE: make this a running average instead to show smoother result.

// The following shows the usual functions required to connect and start running the multi-channel-calibration-with-digital-input scan. 
// Functions required to show the data on the console are at the bottom of the page.
// EX_SetScanType, EX_SetMultiChanScanChans, EX_SetDataLogOptions, even EX_SendRate can be excluded by using "M30x_SP.ini" as described in documentation.  
int __cdecl main()
{
	// DEVELOPER NOTE: You can replace the dot-display below to a progress bar in your GUI type application
	printf("Starting up - please standby .");
	if(!DoInitWithThread()) { printf("\nStartup failed - any key to exit\n"); getch(); return 0; } 
	while(fWaitInit == TRUE)
	{ SleepEx(500, FALSE); printf(" ."); SleepEx(500, FALSE); printf(" ."); SleepEx(500, FALSE); printf(" ."); SleepEx(500, FALSE); printf(" ."); SleepEx(500, FALSE); printf(" .");   }
	if(!fInitSuccess) { printf("Device startup failed - any key to exit\n"); getch(); return 0; } 	

	while(true) {
		if((!EX_SetScanType (usDevID, MULTI_CHAN_CAL_SCAN)) || (!EX_SetMultiChanScanChans (usDevID, 7)) || (!EX_SetDataLogOptions (usDevID, SCAN_USE_DATA_ARRAY, 0, 0))) break; 
		if(!EX_Run (usDevID)) break; fStartSuccess = TRUE; SetCon(); setMainScreen(); break; 
	} if(!fStartSuccess) { printf("Scan startup failed - any key to exit\n"); getch(); return 0; } 

	gotoxy(0,15); printf("AVERAGING - %d", bAvg);
	while(fRunning)
	{
		EX_CheckScanStatus(usDevID, &puiNumScansRemainingInBuff, &pfStillScanning, &puiStatusCode);
		gotoxy(0,4); printf("Scans in buff: % 3u, StatCode: 0x%03X, StillScanning: %s\n", puiNumScansRemainingInBuff, puiStatusCode, pfStillScanning > 0 ? "YES" : " NO");
		if(puiNumScansRemainingInBuff > 0)
		{
			EX_GetScanDataInt (usDevID, piDataBuff, 1, FALSE, &puiNumScansReturned, &puiNumScansRemainingInBuff, &pfStillScanning, &puiTotalBuffSize, &puiStatusCode); 
			showData(1); 
			for(bIndexSub = 0; bIndexSub < 8; bIndexSub++) iAvgBuff[bIndexSub]=iAvgBuff[bIndexSub] + iDataBuff[bIndexSub];
			bAvgCnt++; if(bAvgCnt == bAvg){ bAvgCnt = 0; showData(0); }  
		}
		if(keyChk() || (!pfStillScanning)) { EndScan(); break; }
		
	}   return 1;
}



//###########################
// Connect thread and related
//###########################
HANDLE	hThread_HANDLE = NULL;
DWORD dwThread_ID;
ULONG ThreadFunc(LPVOID pVoid)
{
	while(true) 
	{
		if(!Init()) break; if(!EX_Connect(&usDevID)) break;
		fInitSuccess = TRUE; break; 
	}
	//	if(!EX_SendRate(usDevID, &dblRate)) return FALSE;
	fWaitInit = FALSE;
	return 0;
}

BOOLEAN DoInitWithThread(void)
{
	hThread_HANDLE = CreateThread(NULL, 0, ThreadFunc, NULL, CREATE_SUSPENDED, &dwThread_ID);
	if(!hThread_HANDLE) return FALSE;
	ResumeThread(hThread_HANDLE);
	return TRUE;
}

BOOLEAN Init()
{  
 	hLib301 = LoadLibrary ("LL_USB2k.dll"); if(!hLib301) return FALSE;
	EX_Connect = (P_DLL_EX_CONNECT)GetProcAddress(hLib301, "EX_Connect");
	if(!EX_Connect) return FALSE;
	EX_SendRate = (P_DLL_EX_SEND_RATE)GetProcAddress(hLib301, "EX_SendRate");
	if(!EX_SendRate) return FALSE;
	EX_SetScanType =  (P_DLL_EX_SET_SCAN_TYPE)GetProcAddress(hLib301, "EX_SetScanType");
	if(!EX_SetScanType) return FALSE;
	EX_SetMultiChanScanChans =  (P_DLL_EX_SET_MULTI_CHAN_SCAN_CHANS)GetProcAddress(hLib301, "EX_SetMultiChanScanChans");
	if(!EX_SetMultiChanScanChans) return FALSE;
	EX_SetDataLogOptions =  (P_DLL_EX_SET_DATA_LOG_OPTIONS)GetProcAddress(hLib301, "EX_SetDataLogOptions");
	if(!EX_SetDataLogOptions) return FALSE;
	EX_Run =  (P_DLL_EX_RUN)GetProcAddress(hLib301, "EX_Run");
	if(!EX_Run) return FALSE;
	EX_CheckScanStatus = (P_DLL_EX_CHECK_SCAN_STATUS)GetProcAddress(hLib301, "EX_CheckScanStatus");
	if(!EX_CheckScanStatus) return FALSE;
	EX_GetScanDataInt =  (P_DLL_EX_GET_SCAN_DATA_INT)GetProcAddress(hLib301, "EX_GetScanDataInt");
	if(!EX_GetScanDataInt) return FALSE;
	EX_Stop =  (P_DLL_EX_STOP)GetProcAddress(hLib301, "EX_Stop");
	if(!EX_Stop) return FALSE;
	EX_StopComplete =  (P_DLL_EX_STOP_COMPLETE)GetProcAddress(hLib301, "EX_StopComplete");
	if(!EX_StopComplete) return FALSE;
	memset(iDataBuff, 0, sizeof(iDataBuff));
    return TRUE;
}




//###############
// Misc functions
//###############
void EndScan(void)
{
	if(!fRunning) return;
	gotoxy(0,23); printf("Completing scan stop - wait...."); gotoxy(0,16); 
	if(!EX_Stop(usDevID)) printf("failed to stop scan run\n"); 
	else { EX_StopComplete(usDevID); gotoxy(0,24); printf("\nScan Stopped. Exiting application - please wait\n"); fRunning = FALSE; }
}




//#########################
// Screen support functions
//#########################
void setMainScreen(void)
{ system("cls"); printf("INITIALIZED\nPress 'E' to end scanning and exit" ); }


void showData(BYTE bAvgIndex)
{
	// DEVELOPER NOTE: Each of the channels below subtract the calibration (offset channel) from the actual voltage
	if(bAvgIndex)
	{ 
		gotoxy(0,6); printf("AVERAGING - 1");
		double dblOffsetNoAvg = (((piDataBuff[7]) - 8388608) * 0.00000059604645);
		gotoxy(0,7); printf("chan 0: % 2.5lf\n", (((piDataBuff[0]) - 8388608) * 0.00000059604645) - dblOffsetNoAvg);
		printf("chan 1: % 2.5lf\n", (((piDataBuff[1]) - 8388608)  * 0.00000059604645) - dblOffsetNoAvg);
		printf("chan 2: % 2.5lf\n", (((piDataBuff[2]) - 8388608)  * 0.00000059604645) - dblOffsetNoAvg);
		printf("chan 3: % 2.5lf\n", (((piDataBuff[3]) - 8388608)  * 0.00000059604645) - dblOffsetNoAvg);
		printf("chan 4: % 2.5lf\n", (((piDataBuff[4]) - 8388608)  * 0.00000059604645) - dblOffsetNoAvg);
		printf("chan 5: % 2.5lf\n", (((piDataBuff[5]) - 8388608)  * 0.00000059604645) - dblOffsetNoAvg);
		printf("chan 6: % 2.5lf", (((piDataBuff[6]) - 8388608) * 0.00000059604645) - dblOffsetNoAvg);
		return;
	}

	double dblOffset = (((iAvgBuff[7] / bAvg) - 8388608) * 0.00000059604645);
	gotoxy(0,16); printf("chan 0: % 2.5lf\n", (((iAvgBuff[0] / bAvg) - 8388608) * 0.00000059604645) - dblOffset);
	printf("chan 1: % 2.5lf\n", (((iAvgBuff[1] / bAvg) - 8388608)  * 0.00000059604645) - dblOffset);
	printf("chan 2: % 2.5lf\n", (((iAvgBuff[2] / bAvg) - 8388608)  * 0.00000059604645) - dblOffset);
	printf("chan 3: % 2.5lf\n", (((iAvgBuff[3] / bAvg) - 8388608)  * 0.00000059604645) - dblOffset);
	printf("chan 4: % 2.5lf\n", (((iAvgBuff[4] / bAvg) - 8388608)  * 0.00000059604645) - dblOffset);
	printf("chan 5: % 2.5lf\n", (((iAvgBuff[5] / bAvg) - 8388608)  * 0.00000059604645) - dblOffset);
	printf("chan 6: % 2.5lf\n", (((iAvgBuff[6] / bAvg) - 8388608) * 0.00000059604645) - dblOffset);
	memset(iAvgBuff, 0, sizeof(iAvgBuff));

}



BOOLEAN keyChk()
{
	if(_kbhit())
	{
		iKeyChar = getch(); cUserInputVal = (char)iKeyChar;
		if((cUserInputVal == 27) || (cUserInputVal == 'E') || (cUserInputVal == 'e'))
		{
			EndScan();
			cUserInputVal=0; return TRUE;
		}
		else { gotoxy(0,18); printf("\ngot key: %c\n", (char)iKeyChar); }
	}
	return FALSE;
}

BOOLEAN SetCon(void)
{
	hOutCon = GetStdHandle(STD_OUTPUT_HANDLE);
	if(!hOutCon)
	{ MessageBox(0, "Error writing to console", "-- error", MB_OK); return FALSE; }
	hInCon =  GetStdHandle(STD_INPUT_HANDLE);
	if(!hInCon) { MessageBox(0, "Error reading from console", "-- error", MB_OK); return FALSE; }
	ConsoleCursorInfo.dwSize=1; ConsoleCursorInfo.bVisible = TRUE; SetConsoleCursorInfo(hOutCon, &ConsoleCursorInfo);
	return TRUE;
}



